#!/bin/sh
. /root/gstreamer-examples/func.sh

init_dev
[ $? -ne 0 ] && exit 1

echo " starting gstreamer with $CAM_BW_FMT Source ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR) and write to file ar0234_bayer.raw"
echo " ===================================================================================="
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ==============================================="

setup-pipeline-csi1 -f $CAM_BW_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

$V4L2_CTRL_CAM1_BW


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 \
	v4l2src num-buffers=$NUMBER_OF_PIC device=$VID_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8,$FRAME_SIZE ! \
	multifilesink location=ar0234_mono.raw

echo "File \"ar0234_mono.raw\" ($CAM_BW_FORMAT,$FRAME_SIZE)"
