#!/bin/sh

source /root/gstreamer-examples/func.sh

init_dual_dev
[ $? -ne 0 ] && exit 1

source /usr/share/phytec-gstreamer-examples/ar0234.conf
SENSOR_RES="1920x1080"
GRAB_RES="1920x1080"
FRAME_SIZE="width=1920,height=1080"
BW_FORMAT="raw,format=GRAY8,depth=8"


echo ""
echo " starting gstreamer with two GRAY Sources ..."
echo " read CAM1 from MIPI-CSI-2_CSI1 and CAM2 from MIPI-CSI-2_CSI2 with $GRAB_RES"
echo " write side by side to sink device"
echo " =================================================================================="
echo ""
echo " configure camera with v4l2_control"
echo " =================================="

setup-pipeline-csi1 -f $CAM_BW_FMT -s $GRAB_RES -o $OFFSET_SENSOR -c $SENSOR_RES
setup-pipeline-csi2 -f $CAM_BW_FMT -s $GRAB_RES -o $OFFSET_SENSOR -c $SENSOR_RES


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

V4L2_CTRL_CAM_BW="v4l2-ctl -d ${CAM_DEVICE_1} -c ${CTRLS_BW}"
$V4L2_CTRL_CAM_BW
V4L2_CTRL_CAM_BW="v4l2-ctl -d ${CAM_DEVICE_2} -c ${CTRLS_BW}"
$V4L2_CTRL_CAM_BW


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 imxcompositor_g2d name=mix sink_0::xpos=0 sink_0::ypos=0 sink_1::xpos=1920 sink_1::ypos=0 ! queue ! waylandsink sync=false \
	v4l2src device=$VID_DEVICE_1 ! \
	video/x-$BW_FORMAT,$FRAME_SIZE,framerate=30/1 ! videoconvert n-threads=4 ! mix. \
	v4l2src device=$VID_DEVICE_2 ! \
	video/x-$BW_FORMAT,$FRAME_SIZE,framerate=30/1 ! videoconvert n-threads=4 ! mix.
