#!/bin/sh

source /root/gstreamer-examples/func.sh

init_dual_dev
[ $? -ne 0 ] && exit 1

source /usr/share/phytec-gstreamer-examples/ar0234.conf

echo ""
echo " starting gstreamer with two BAYER Sources ..."
echo " read CAM1 from MIPI-CSI-2_CSI1 and CAM2 from MIPI-CSI-2_CSI2 with $SENSOR_RES"
echo " write side by side to 3840x1200 Pixel, convert to jpg and write to ar0234_col_dual_image.jpg"
echo " ============================================================================================"
echo ""
echo " configure camera with v4l2_control"
echo " =================================="

setup-pipeline-csi1 -f $CAM_COL_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES
setup-pipeline-csi2 -f $CAM_COL_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES

echo ""
echo " configure camera @CAM1/2 with v4l2_control"
echo " =========================================="

V4L2_CTRL_CAM_COL="v4l2-ctl -d ${CAM_DEVICE_1} -c ${CTRLS_COL}"
$V4L2_CTRL_CAM_COL
V4L2_CTRL_CAM_COL="v4l2-ctl -d ${CAM_DEVICE_2} -c ${CTRLS_COL}"
$V4L2_CTRL_CAM_COL


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 videomixer name=mix  sink_0::xpos=0 sink_0::ypos=0 sink_1::xpos=1920 sink_1::ypos=0 ! queue ! jpegenc ! multifilesink location=ar0234_col_dual_image.jpg \
	v4l2src num-buffers=8 device=$VID_DEVICE_1 ! \
	video/x-$COL_FORMAT,$FRAME_SIZE,framerate=30/1 ! bayer2rgbneon ! queue ! imxvideoconvert_g2d ! mix. \
	v4l2src num-buffers=8 device=$VID_DEVICE_2 ! \
	video/x-$COL_FORMAT,$FRAME_SIZE,framerate=30/1 ! bayer2rgbneon ! queue ! imxvideoconvert_g2d ! mix.

#gst-launch-1.0 \
#	v4l2src num-buffers=5 device=$VID_DEVICE_1 ! video/x-$COL_FORMAT,$FRAME_SIZE,framerate=30/1 ! \
#	bayer2rgbneon ! videoconvert ! jpegenc ! multifilesink location=ar0234_col_image_cam1.jpg &
#gst-launch-1.0 \
#	v4l2src num-buffers=5 device=$VID_DEVICE_2 ! video/x-$COL_FORMAT,$FRAME_SIZE,framerate=30/1 ! \
#	bayer2rgbneon ! videoconvert ! jpegenc ! multifilesink location=ar0234_col_image_cam2.jpg

