#!/bin/sh

source /root/gstreamer-examples/func.sh

init_dual_dev
[ $? -ne 0 ] && exit 1

SENSOR_RES="2560x1920"
GRAB_RES="640x480"
FRAME_SIZE="width=640,height=480"
OFFSET_SENSOR="(0,4)"
CAM_COL_FMT="SGRBG8_1X8"
COL_FORMAT="bayer,format=grbg,depth=8"

echo ""
echo " starting gstreamer with two BAYER Sources ..."
echo " read CAM1 from MIPI-CSI-2_CSI1 and CAM2 from MIPI-CSI-2_CSI2 with $GRAB_RES"
echo " write side by side to sink device"
echo " =================================================================================="
echo ""
echo " configure camera with v4l2_control"
echo " =================================="

setup-pipeline-csi1 -f $CAM_COL_FMT -s $GRAB_RES -o $OFFSET_SENSOR -c $SENSOR_RES
setup-pipeline-csi2 -f $CAM_COL_FMT -s $GRAB_RES -o $OFFSET_SENSOR -c $SENSOR_RES


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

v4l2-ctl -d $CAM_DEVICE_1 -c exposure=2240,analogue_gain=8000,digital_gain_red=1400,digital_gain_blue=1400,dynamic_defect_pixel_correction=1
v4l2-ctl -d $CAM_DEVICE_2 -c exposure=2240,analogue_gain=8000,digital_gain_red=1400,digital_gain_blue=1400,dynamic_defect_pixel_correction=1


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 videomixer name=mix sink_0::xpos=0 sink_0::ypos=0 sink_1::xpos=640 sink_1::ypos=0 ! waylandsink sync=false \
	v4l2src device=$VID_DEVICE_1 ! \
	video/x-$COL_FORMAT,$FRAME_SIZE,framerate=30/1 ! bayer2rgb ! queue ! videoconvert ! mix. \
	v4l2src device=$VID_DEVICE_2 ! \
	video/x-$COL_FORMAT,$FRAME_SIZE,framerate=30/1 ! bayer2rgb ! queue ! videoconvert ! mix.
